/***********************
   read FatFs_readme.h
 ***********************/
#ifndef SDCARD_h
#define SDCARD_h

#include <Arduino.h>

// Status of Disk Functions
typedef uint8_t  DSTATUS;

// Results of Disk Functions
typedef enum {
  RES_OK = 0, // 0: Successful
  RES_ERROR,  // 1: R/W Error
  RES_WRPRT,  // 2: Write Protected
  RES_NOTRDY, // 3: Not Ready
  RES_PARERR  // 4: Invalid Parameter
} DRESULT;

// Disk Status Bits (DSTATUS)
#define STA_NOINIT  0x01  // Drive not initialized 
#define STA_NODISK  0x02  // No medium in the drive 
#define STA_PROTECT 0x04  // Write protected 

// MMC card type flags (MMC_GET_TYPE)
#define CT_MMC   0x01  // MMC ver 3 
#define CT_SD1   0x02  // SD ver 1 
#define CT_SD2   0x04  // SD ver 2 
#define CT_SDC   (CT_SD1|CT_SD2)  // SD 
#define CT_BLOCK 0x08  // Block addressing 

class SdSpi {
  public:
    void pinSS(uint8_t pin);  // SS pin
    DSTATUS disk_initialize ();  // Initialize Disk Drive
    DSTATUS disk_status ();  // Get Disk Status
    DRESULT disk_read (byte* buff, uint32_t sector, uint16_t count);  // Read Sector(s)
    DRESULT disk_write (const byte* buff, uint32_t sector, uint16_t count);  // Write Sector(s)
    DRESULT disk_ioctl ();  // stripped in/out control
    uint32_t get_fattime ();  // dummy time ** insert your own RTC code ** Fixed to Jan. 1, 2010
};

#endif


